----------------------------------------
-- All players vs. zombies (coop play)
-- by Vectar666
----------------------------------------
-- SETTINGS
moneyforNPCHP=	1 		-- money for NPC hp hit
trtprice	=	14000 	-- turret price
trtlimit	=	1 		-- turret limit (many turrets cause LAGS)
minpl		=	6 		-- minimum players - if players<minpl then bots are added.
s_effects	=	1 		-- that effect command is very consuming...
berserk_kxp	=	0.25 	-- how many xp for berserk-killed NPCs? (koefficient)
aura_kxp	=	0.2 	-- and for aura-killed?
allow_nuke	=	1		-- allows players to buy NUKE
aura_color	=	{255,0,0} -- aura color
npc_blood_color={}
npc_blood_color[1]={r=155;g=0;b=0} 	-- zombie blood color
npc_blood_color[2]={r=65;g=195;b=5} 		-- headcrab blood color
npc_blood_color[3]={r=80;g=195;b=5}		-- snark blood color
npc_blood_color[4]={r=70;g=195;b=5}		-- vort blood color
npc_blood_color[5]={r=200;g=0;b=5}	-- soldier color
--msg stuff
msg_color_mtext	=	"255255000" 	-- color of the text shown each minute
msg_color_mana	=	"000055255" 	-- mana hudtxt color
msg_color_lvl	=	"155255000" 	-- lvl hudtxt color
msg_color_xp	=	"200255000" 	-- xp hudtxt color
msg_color_lvlup	=	"005255100" 	-- "Level up!" message color
msg_color_saved	=	"000255000"		-- colour of message "your data has been saved!"
msg_color_forget=	"055255200"		-- colour about free points after "forget" spell.

-- ENDSETTINGS xD

function toTable(t,match)
     local cmd = {}
     if not match then
          match = "[^%s]+"
     else
          match = "[^"..match.."]+"
     end
     for word in string.gmatch(t, match) do
          table.insert(cmd, word)
     end
     return cmd
end

function belongs_to_table(t,value)
    for i=1,#t do
        if t[i]==value then
            return true
        end
    end
    return false
end

function direction(x1,y1,x2,y2)
	return math.deg(math.atan2(x2-x1,y1-y2))
end

function viewline(x1,y1,x2,y2,ttx,tty)
	local xd,yd,e,d,ix,iy,tx,ty,ot
	local r=true
	xd=math.ceil((x2-x1)/30)
	yd=math.ceil((y1-y2)/30)
	d=30
	e=math.sqrt((x2-x1)^2+(y1+y2)^2)
	if xd~=0 then xd=(x2-x1)/d end
	if yd~=0 then yd=(y1-y2)/d end
	ix=x1
	iy=y1
	ot=object(0,"table")
	for i=0,e,d do
		ix=ix+xd
		iy=iy-yd
		tx=math.floor(ix/32)
		ty=math.floor(iy/32)
		if not (ty==tty and tx==ttx) then
			if tile(tx,ty,"wall") then
				r=false
				break
			else
				for j=1,#ot do
					if object(ot[j],"tilex")==tx and object(ot[j],"tiley")==ty and object(ot[j],"type")~=30 then
						r=false
						break
					end
				end
				if r==false then
					break
				end
			end
		end
	end
	return r
end

function remotetxt()
	local fl,b,c=0
	--msg
	fl = io.open("sys/lua/npczm_remote/msg.lst","r")
	if (fl ~= nil) then
		b=0
		for line in fl:lines() do
			b=b+1
			if b==1 and (line=="" or line==" ") then
				c=1
				break
			else
				msg(line.."@C")
			end
		end
		fl:close()
	end
	--parse
	fl = io.open("sys/lua/npczm_remote/parse.lst","r")
	if (fl ~= nil) then
		b=0
		for line in fl:lines() do
			b=b+1
			if b==1 and (line=="" or line==" ") then
				c=1
				break
			else
				parse(line)
			end
		end
		fl:close()
	end
end

parse("mp_killbuildings 0")
parse("mp_building_limit \"Wall I\" 1")
parse("mp_building_limit \"Wall II\" 1")
parse("mp_building_limit \"Wall III\" 1")
parse("mp_wpndmg \"Grenade Launcher\" 200")
parse("mp_wpndmg \"Rocket Launcher\" 300")
parse("mp_wpndmg \"RPG Launcher\" 750")
nuketimg="gfx/PLvsNPCzm/nuke.bmp"
nukeflareimg="gfx/sprites/flare2.bmp"
trtimg="gfx/PLvsNPCzm/rturret_g.bmp"
trtpimg="gfx/PLvsNPCzm/rturret_r.bmp"
trtbimg="gfx/PLvsNPCzm/rturret_b.bmp"
lvlc=1000
lvli={}
lvlir={}
lvl={}
xp={}
lvlsk={}
hpp={}
app={}
ecp={}
spp={}
invul={}
invuls={}
ber={}
regen={}
bers={}
aura={}
auras={}
manap={}
mana={}
hasnuke={}
nukes={}
nukes[1]={}
nukes[1].exists=false
nukes[1].x=0
nukes[1].y=0
nukes[1].planted=false
nukes[1].timer=0
nukes[1].beepalpha=0
trts={}
rckts={}
for i=1,100 do
	trts[i]={}
	trts[i].exists=false
	rckts[i]={}
	rckts[i].exists=false
end
nukeimg={}
nukesimg={}
nukesimg[1]=nil
nukeimg[1]=nil
auraimg={}
tsec=3
tsec2=10
for i=1,32 do
	spp[i]=0
	lvli[i]=10000
	lvlir[i]=10500
	lvl[i]=0
	xp[i]=0
	lvlsk[i]=0
	hpp[i]=0
	app[i]=0
	ecp[i]=0
	invul[i]=0
	ber[i]=0
	bers[i]=0
	regen[i]=0
	invuls[i]=0
	aura[i]=0
	auras[i]=0
	manap[i]=0
	hasnuke[i]=0
	mana[i]=35
	auraimg[i]=false
end

addhook("objectkill","npckill",2)
addhook("objectdamage","npchit",1)
addhook("hit","playerhit")
addhook("serveraction","srvact")
addhook("menu","fbuy")
addhook("minute","tips")
addhook("spawn","reminder")
addhook("join","refresh")
addhook("second","eachsec")
addhook("ms100","fastrfh")
addhook("buy","buyequip")
addhook("die","playerdie")
addhook("movetile","pickup_itms")
addhook("buildattempt","trtbuild")
addhook("leave","lupd")
addhook("startround","supd",1)

function supd()
	for i=1,#rckts do
		if rckts[i].exists then
			freeimage(rckts[i].img)
			rckts[i].exists=false
		end
	end
	for i=1,#trts do
		if trts[i].exists then
			trts[i].exists=false
			freeimage(trts[i].bimg)
			freeimage(trts[i].gimg)
		end
	end
	for i=1,#nukes do
		if nukes[i].exists then
			nukes[i].exists=false
			refreshgfx(i,"nuke",0)
		end
	end
end

-- function gives player a nuke if he walked over it.
function pickup_itms(id,tx,ty)
	for i=1,#nukes do
		if nukes[i]~=nil and nukes[i].exists and not nukes[i].planted and hasnuke[id]==0 and nukes[i].x==tx and nukes[i].y==ty then
			nukes[i].exists=false
			refreshgfx(i,"nuke",0)
			hasnuke[id]=1
			parse("sv_sound2 "..id.." items/pickup.wav")
			msg2(id,"000255000You picked up a NUKE!@C")
			msg2(id,"000255000Use F4->Plant Nuke to plant it!@C")
		end
	end
end

----------------------------------------------------------------
-- this function creates/removes images if necessary
-- (id=id of image, type= "nuke" or "nukeflare", mode is
-- 0/1 for refresh/remove for nuke, and 0-5 for alpha for flare.)
----------------------------------------------------------------
function refreshgfx(id,type,mode)
	local rndrot
	if type=="nuke" then
		if mode==1 then
			if nukeimg[id]==nil then
				nukeimg[id]=image(nuketimg,0,0,0)
			end
			rndrot=math.random(0,359)
			imagepos(nukeimg[id],nukes[id].x*32+16,nukes[id].y*32+16,rndrot)
			imagescale(nukeimg[id],2,2)
			imagealpha(nukeimg[id],1)
		elseif mode==0 then
			if nukeimg[id]~=nil then
				freeimage(nukeimg[id])
				nukeimg[id]=nil
			end
		else
		print("incorrect MODE setting!")
		end
	elseif type=="nukeflare" then
		if mode>0 then
			if nukesimg[id]==nil then
				nukesimg[id]=image(nukeflareimg,0,0,3)
			end
			rndrot=math.random(0,359)
			imagepos(nukesimg[id],nukes[id].x*32+16,nukes[id].y*32+16,rndrot)
			imagecolor(nukesimg[id],255,10,10)
			imageblend(nukesimg[id],1)
			imagescale(nukesimg[id],0.7,0.7)
			imagealpha(nukesimg[id],mode/5)
		else
			if nukesimg[id]~=nil then
				freeimage(nukesimg[id])
				nukesimg[id]=nil
			end
		end
	elseif type=="aura" then
		if not auraimg[id] and auras[id]>0 then
			auraimg[id]=image("gfx/sprites/flare2.bmp",0,1,id+132)
			math.randomseed(os.clock())
			tween_rotateconstantly(auraimg[id],math.random(-5,5))
			imageblend(auraimg[id],1)
			imagecolor(auraimg[id],aura_color[1],aura_color[2],aura_color[3])
			imagealpha(auraimg[id],0.8)
			imagescale(auraimg[id],0.1,0.1)
			tween_scale(auraimg[id],300,0.5+aura[id]/32,0.5+aura[id]/32)
		end
		if auraimg[id] and auras[id]<=0 then
			freeimage(auraimg[id])
			auraimg[id]=false
		end
	end
end

-- nuke is dropped and is availible for pick up
function dropnuke(x,y)
	local tilex,tiley
	tilex=math.floor(x/32)
	tiley=math.floor(y/32)
	for i=1,#nukes+1 do
		if nukes[i]==nil or not nukes[i].exists then
			nukes[i]={}
			nukes[i].exists=1
			nukes[i].x=tilex
			nukes[i].y=tiley
			nukes[i].planted=false
			nukes[i].timer=0
			nukes[i].mtimer=0
			nukes[i].beepalpha=0
			refreshgfx(i,"nuke",1)
			break
		end
	end
end

-- Plantin' nuke!
function plantnuke(tx,ty,pl)
	for i=1,#nukes+1 do
		if nukes[i]==nil or not nukes[i].exists then
			nukes[i]={}
			nukes[i].exists=1
			nukes[i].x=tx
			nukes[i].y=ty
			nukes[i].planted=true
			nukes[i].timer=20
			nukes[i].mtimer=0
			nukes[i].beepalpha=0
			nukes[i].id=pl
			refreshgfx(i,"nuke",1)
			break
		end
	end
end

--Droppin' nuke on death!
function playerdie(id,na,nb,x,y)
	if hasnuke[id]==1 then
		hasnuke[id]=0
		dropnuke(x,y)
	end
	parse("hudtxt2 "..id.." 4")
end
-----------------------------------------------------------------------------
-- Turrets stuff: turrets doesn't kill zombies, because of AI,
-- so I decided to create lua turrets. One problem: there is
-- no "damageNPC" cmd, but there is "Explosion" command which affects zombies!
-- So, these are Rocket turrets! Yay!
-----------------------------------------------------------------------------

function trtbuild(id,type,x,y)
	local k=0
	if type==8 then
		if player(id,"money")>=trtprice then
			for i=1,#trts do
				if trts[i].exists and trts[i].pid==id then
					k=k+1
				end
			end
			if k<trtlimit then
				parse("spawnobject 3 "..x.." "..y.." 90 1 "..player(id,"team").." "..id)
				addtrt(id,x,y)
				parse("setmoney "..id.." "..(player(id,"money")-trtprice))
			else
				msg2(id,"255000000You can't build more@C")
			end
		else
			msg2(id,"255000000You have insufficient funds!@C")
		end
		return 1
	end
end

function addtrt(pid,x,y)
	local cid=#trts+1
	for i=1,#trts do
		if  not trts[i].exists then
			cid=i
			break
		end
	end
	local px=x*32+16
	local py=y*32+16
	trts[cid]={
		exists=true;
		timer=0;
		rot=0;
		rotc=0;
		tx=x;
		ty=y;
		px=px;
		py=py;
		team=player(pid,"team");
		pid=pid;
		bimg=image(trtbimg,px,py,1);
		gimg=image(trtimg,px,py,3)
	}
end

function trt_shoot(tid)
	local cid=#rckts+1
	local ot=object(0,"table")
	for i=1,#rckts do
		if  not rckts[i].exists then
			cid=i
			break
		end
	end
	rckts[cid]={
		exists=true;
		vx=math.sin(math.rad(trts[tid].rot))*30;
		vy=-math.cos(math.rad(trts[tid].rot))*30;
		x=trts[tid].px;
		y=trts[tid].py;
		rot=trts[tid].rot;
		img=image(trtpimg,0,0,1);
		tid=tid
	}
	for j=1,#ot do
		if object(ot[j],"tilex")==trts[tid].tx and object(ot[j],"tiley")==trts[tid].ty then
			rckts[cid].ignore=ot[j]
			break
		end
	end
	imagepos(rckts[cid].img,trts[tid].px,trts[tid].py,rckts[cid].rot)
end

function rocketupdate()
	local tx,ty,ot,d
	ot=object(0,"table")
	for i=1,#rckts do
		if rckts[i].exists then
			rckts[i].x=rckts[i].x+rckts[i].vx
			rckts[i].y=rckts[i].y+rckts[i].vy
			tx=math.floor(rckts[i].x/32)
			ty=math.floor(rckts[i].y/32)
			d=0
			if not (tx==trts[rckts[i].tid].tx and ty==trts[rckts[i].tid].ty) then
				if tile(tx,ty,"wall") then
					d=1
				else
					for j=1,#ot do
						if math.sqrt((object(ot[j],"x")-rckts[i].x)^2+(object(ot[j],"y")-rckts[i].y)^2)<=16 and ot[j]~=rckts[i].ignore then
							d=1
							break
						end
					end
				end
			end
			if d==1 then
				parse("explosion "..rckts[i].x.." "..rckts[i].y.." 80 90 "..trts[rckts[i].tid].pid)
				freeimage(rckts[i].img)
				rckts[i].exists=false
			else
				imagepos(rckts[i].img,rckts[i].x,rckts[i].y,rckts[i].rot)
			end
		end
	end
end

function trtseeknpc(trtid)
	local ot=object(0,"table")
	local oi
	local rto=0
	for i=1,#ot do
		oi=ot[i]
		--oi=i
		if object(oi,"exists") and object(oi,"type")==30 and object(oi,"health")>0 then --living NPC
			if math.sqrt((trts[trtid].px-object(oi,"x"))^2+(trts[trtid].py-object(oi,"y"))^2)<=640 then
				if viewline(trts[trtid].px,trts[trtid].py,object(oi,"x"),object(oi,"y"),trts[trtid].tx,trts[trtid].ty) then
					rto=oi
					break
				end
			end
		end
	end
	return rto
end

function trtupdate()
	local k=0
	local sn
	for i=1,#trts do
		if trts[i].exists then
			if trts[i].timer>0 then trts[i].timer=trts[i].timer-1 end
			sn=trtseeknpc(i)
			if sn>0 then
				trts[i].rot=direction(trts[i].px,trts[i].py,object(sn,"x"),object(sn,"y"))
				if trts[i].timer<=0 then
					trt_shoot(i)
					trts[i].timer=6
				end
			else
				trts[i].rotc=trts[i].rotc+1
				if trts[i].rotc>=30 then
					trts[i].rot=trts[i].rot+3
				else
					trts[i].rot=trts[i].rot-3
				end
				if trts[i].rotc>=60 then trts[i].rotc=0 end
			end
			imagepos(trts[i].gimg,(trts[i].tx*32+16),(trts[i].ty*32+16),trts[i].rot)
		end
	end
end

function trtdestroy(x,y)
	for i=1,#trts do
		if trts[i].exists and trts[i].tx==x and trts[i].ty==y then
			trts[i].exists=false
			freeimage(trts[i].bimg)
			freeimage(trts[i].gimg)
			parse("explosion "..(x*32+16).." "..(y*32+16).." 32 0 0")
		end
	end
end

-----------------------------------------------------------------------------------------
-- this function gives weapons to player if he buyes it, so he can buy a lot of primaries!
-----------------------------------------------------------------------------------------
function buyequip(id,wpn)
	if not (wpn>=51 and wpn<=62) then
		if player(id,"money")>=itemtype(wpn,"price") then
			if not (belongs_to_table(playerweapons(id),wpn)) then
				parse("sv_sound2 "..id.." items/pickup.wav")
				parse("equip "..id.." "..wpn)
				parse("setweapon "..id.." "..wpn)
				msg2(id,"000255000You successfully bought "..itemtype(wpn,"name").."!@C")
				parse("setmoney "..id.." "..(player(id,"money")-itemtype(wpn,"price")))
			else
				msg2(id,"You already have this or something better@C")
			end
		else
			msg2(id,"You have insufficient funds!@C")
		end
		return 1
	end
end

----------------------------------------------------------------------------------------------------------
-- ms100 hook for refresh nuke flare and killing zombies with aura, if possible. also starts rcktupdate.
----------------------------------------------------------------------------------------------------------
function fastrfh()
	trtupdate()
	rocketupdate()
	for i=1,#nukes do
		if nukes[i]~=nil and nukes[i].planted==true then
			if nukes[i].mtimer>=0 then
				refreshgfx(i,"nukeflare",nukes[i].mtimer)
				nukes[i].mtimer=nukes[i].mtimer-1
			end
		end
	end
	for i=1,32 do
		if player(i,"exists") then
			--aura
			if auras[i]>0 then
				ot=object(0,"table")
				for j=1,#ot do
					if object(ot[j],"exists") and object(ot[j],"health")>0 and object(ot[j],"type")==30 and math.sqrt((object(ot[j],"x")-player(i,"x"))^2+(object(ot[j],"y")-player(i,"y"))^2)<(32+aura[i]*2)then
						dmgg=object(ot[j],"health")*aura_kxp
						parse("setmoney "..i.." "..(player(i,"money")+moneyforNPCHP*dmgg+ecp[i]))
						xp[i]=math.floor(xp[i]+dmgg)
						parse('hudtxt2 '..i..' 1 "'..msg_color_xp..'Experience: '..xp[i]..'/'..lvli[i]..'" 300 415 0')
						checklevel(i)
						parse("killobject "..ot[j])
					end
				end
			end
		end
	end
end

------------------------------------
-- refresh, more slow, second hook.
------------------------------------
function eachsec()
	local ot,plt
	if tsec==0 then  tsec=3 end
	if tsec2==0 then tsec2=10 end
	tsec=tsec-1
	tsec2=tsec2-1
	parse("mp_building_price Turret "..trtprice)
	--NUKE
	for i=1,#nukes do
		if nukes[i]~=nil and nukes[i].planted==true then
			if nukes[i].timer>0 then
				nukes[i].mtimer=5
				nukes[i].timer=nukes[i].timer-1
			else
				refreshgfx(i,"nuke",0)
				parse("explosion "..(nukes[i].x*32+16).." "..(nukes[i].y*32+16).." 3500 10000 "..nukes[i].id)
				parse("explosion "..(nukes[i].x*32+16).." "..(nukes[i].y*32+16).." 5000 30000")
				if s_effects==1 then parse("effect \"smoke\" "..(nukes[i].x*32+16).." "..(nukes[i].y*32+16).." 1 4500") end
				nukes[i]=nil
			end
		end
	end
	for i=1,32 do
		if player(i,"exists") then
			--regen
			if regen[i]>0 then
				parse("sethealth "..i.." "..(player(i,"health")+regen[i]))
			end
			--invulnerability
			if invuls[i]>0 then
				invuls[i]=invuls[i]-1
			end
			--berserk
			if bers[i]>0 then
				bers[i]=bers[i]-1
			end
			--aura
			if auras[i]>0 then auras[i]=auras[i]-1; refreshgfx(i,"aura") end
			--mana
			if tsec==0 then
				if mana[i]<(33+manap[i]*10+lvl[i]*2) then
					mana[i]=mana[i]+1+manap[i]
					if mana[i]>(33+manap[i]*10+lvl[i]*2) then mana[i]=(33+manap[i]*10+lvl[i]*2) end
				end
			end
			parse('hudtxt2 '..i..' 3 "'..msg_color_mana..'Mana: '..mana[i]..'/'..(33+manap[i]*10+lvl[i]*2)..'" 150 415 0')
			if hasnuke[i]==1 then
				parse("hudtxt2 "..i.." 4 \"000255000NUKE\" 5 250 0")
			else
				parse("hudtxt2 "..i.." 4")
			end
		end
	end
	if tsec2==0 then
		--remotetxt()
		plt=player(0,"table")
		if #plt<minpl then
			for abc=1,(minpl-#plt) do
				parse("bot_add")
			end
		elseif #plt>minpl then
			for abc=1,(#plt-minpl) do
				parse("bot_remove")
			end
		end
	end
end

----------------------------
-- another refresh thingy
----------------------------
function lupd(id)
	for i=1,#trts do
		if trts[i].exists and trts[i].pid==id then
			trts[i].exists=false
			freeimage(trts[i].bimg)
			freeimage(trts[i].gimg)
			parse("explosion "..(x*32+16).." "..(y*32+16).." 32 0 0")
		end
	end
end


-----------------------
-- serveraction buttons!
-----------------------
function srvact(id,btn)
	local txt="Active Abilities@b,Forget|Forget all the skills to get all free points - costs $10000,"
	local buymenutxt="Buy menu,Grenade Launcher|$11000,Medikit|$2000,Airstrike|$4000,Chainsaw|$10000,Rocket launcher|$13000,RPG|$13500"
	local skillztxt="Skills@b,"
	if btn==1 then
		if allow_nuke==1 then buymenutxt=buymenutxt..",Nuke|$16000" end
		menu(id,buymenutxt)
	elseif btn==2 then
		if lvlsk[id]>0 then
			if hpp[id]<10 then
				skillztxt=skillztxt.."health|+15HP"
			else
				skillztxt=skillztxt.."(health [Maximum reached!])"
			end
			skillztxt=skillztxt..","
			if app[id]<25 then
				skillztxt=skillztxt.."armor|+10AP"
			else
				skillztxt=skillztxt.."(armor [Maximum reached!])"
			end
			skillztxt=skillztxt..",economist|+$5 for each profit,"
			if spp[id]<100 then
				skillztxt=skillztxt.."Speed|increasing by 1"
			else
				skillztxt=skillztxt.."(Speed [Maximum reached!])"
			end
			menu(id,skillztxt..",Invulnerability,Berserk|deadly knife,DMG aura|aura kills zombies some seconds,Regeneration|adding health 1*skillLVL,Intelligence|+5 mana and +1 regen")
		end
	elseif btn==3 then
		if invul[id]>0 then
			if mana[id]<(30+invul[id]*3) then
				txt=txt.."(Invulnerability [no health less during "..(invul[id]*5).." seconds. Costs "..(30+invul[id]*3).." mana])"
			else
				txt=txt.."Invulnerability|no health less during "..(invul[id]*5).." seconds. Costs "..(30+invul[id]*3).." mana"
			end
		end
		txt=txt..","
		if ber[id]>0 then
			if mana[id]<(25+ber[id]*5) then
				txt=txt.."(Berserk [Deadly knife hits during "..(ber[id]*5).." seconds. Costs "..(25+ber[id]*5).." mana])"
			else
				txt=txt.."Berserk|Deadly knife hits during "..(ber[id]*5).." seconds. Costs "..(25+ber[id]*5).." mana"
			end
		end
		txt=txt..","
		if aura[id]>0 then
			if mana[id]<(20+aura[id]*5) then
				txt=txt.."(DMG aura [Kills zombies during "..aura[id].." seconds. Costs "..(20+aura[id]*5).." mana])"
			else
				txt=txt.."DMG aura|Kills zombies during "..aura[id].." seconds. Costs "..(20+aura[id]*5).." mana"
			end
		end
		txt=txt..","
		if hasnuke[id]>0 then txt=txt.."Plant Nuke |DEADLY Explosion for players and zombies!,Drop Nuke |drop nuke on the ground" end
		menu(id,txt)
	end
end

-------------------------------------------------------------------------------
-- This function refreshes player to minimum, + loads player, if he is saved.
-------------------------------------------------------------------------------
function refresh(i)
	lvli[i]=10000
	lvlir[i]=10500
	lvl[i]=0
	xp[i]=0
	lvlsk[i]=0
	hpp[i]=0
	app[i]=0
	ecp[i]=0
	invul[i]=0
	invuls[i]=0
	ber[i]=0
	bers[i]=0
	regen[i]=0
	aura[i]=0
	auras[i]=0
	manap[i]=0
	mana[i]=35
	hasnuke[i]=0
	exp_load(i)
end

-----------------------------------------------------
-- function for renull all the skills and get pointz
-----------------------------------------------------
function forget(id)
	lvlsk[id]=lvlsk[id]+hpp[id]+app[id]+(ecp[id]/5)+spp[id]+aura[id]+regen[id]+invul[id]+ber[id]+manap[id]
	hpp[id]=0
	app[id]=0
	ecp[id]=0
	spp[id]=0
	aura[id]=0
	regen[id]=0
	invul[id]=0
	ber[id]=0
	manap[id]=0
	msg2(id,""..msg_color_forget.."You now have "..lvlsk[id].." free points!")
end


----------
-- spawn!
----------
function reminder(id)
	parse("setmaxhealth "..id.." "..(100+hpp[id]*15))
	if app[id]<=20 then
		parse("setarmor "..id.." "..(app[id]*10))
	else
		parse("setarmor "..id.." "..(180+app[id]))
	end
	parse("speedmod "..id.." "..spp[id])
	mana[id]=10
		parse('hudtxt2 '..id..' 1 "'..msg_color_xp..'Experience: '..xp[id]..'/'..lvli[id]..'" 300 415 0')
		parse('hudtxt2 '..id..' 2 "'..msg_color_lvl..'Level: '..lvl[id]..'" 5 415 0')
		if hasnuke[id]==1 then
			parse("hudtxt2 "..id.." 4 '000255000NUKE' 5 250 0")
		else
			parse("hudtxt2 "..id.." 4")
		end
end

---------------------------------
-- has player reached new level?
---------------------------------
function checklevel(id)
	if xp[id]>=lvli[id] then
		lvl[id]=lvl[id]+1
		lvlsk[id]=lvlsk[id]+1
		msg2(id,""..msg_color_lvlup.."Level up!@C")
		msg2(id,""..msg_color_lvlup.."Press F3 to choose skill@C")
		if s_effects==1 then parse("effect \"flare\" "..player(id,"x").." "..player(id,"y").." 5 15 255 245 0") end
		lvlir[id]=lvlir[id]+lvlc
		lvli[id]=lvli[id]+lvlir[id]
		parse('hudtxt2 '..id..' 1 "'..msg_color_xp..'Experience: '..xp[id]..'/'..lvli[id]..'" 300 415 0')
		parse('hudtxt2 '..id..' 2 "'..msg_color_lvl..'Level: '..lvl[id]..'" 5 415 0')
		exp_save()
	end
end

------------------
-- minute refresh
------------------
function tips()
	msg(""..msg_color_mtext.."press F2 for buy menu")
	msg(""..msg_color_mtext.."press F3 for lvl skills menu")
	msg(""..msg_color_mtext.."press F4 for active special abilities menu")
	msg(""..msg_color_mtext.."if you want to rechoose your skills, use \"forget\" ability(F4->Forget)")
	msg(""..msg_color_mtext.."It costs $10000")
	exp_save()
end

-----------------------------------------------------------
-- 2 functions - npc damage/kill stuff, turret kill check
-----------------------------------------------------------
function npckill(oid,pid,lol)
	if object(oid,"type")==30 then
	if s_effects==1 and not lol then parse("effect \"colorsmoke\" "..object(oid,"x").." "..object(oid,"y").." 20 10 "..(npc_blood_color[object(oid,"player")].r).." "..(npc_blood_color[object(oid,"player")].g).." "..(npc_blood_color[object(oid,"player")].b)) end
		if pid>0 then
			parse("setscore "..pid.." "..(player(pid,"score")+1))
			print(player(pid,"name").." killed Creature")
			checklevel(pid)
		end
	elseif object(oid,"type")>2 and object(oid,"type")<6 then
		trtdestroy(object(oid,"tilex"),object(oid,"tiley"))
	end
end

function npchit(oid,dmg,pid)
	local dmgg
	if object(oid,"type")==30 then
		if pid>0 then
			if dmg>object(oid,"health") then dmgg=object(oid,"health") else dmgg=dmg end
			if player(pid,"weapontype")==50 then
				if bers[pid]>0 then
					dmgg=object(oid,"health")*berserk_kxp
					npckill(oid,pid,true)
					parse("killobject "..oid)
				end
			end
			parse("setmoney "..pid.." "..(player(pid,"money")+moneyforNPCHP*dmgg+ecp[pid]))
			xp[pid]=math.floor(xp[pid]+dmgg)
			parse('hudtxt2 '..pid..' 1 "'..msg_color_xp..'Experience: '..xp[pid]..'/'..lvli[pid]..'" 300 415 0')
			checklevel(pid)
		end
	end
end


---------------------------------------------------------------------------
-- little function below makes player invulnerable
-- for other players and vulnerable to NPCs if there is no invulnerability
-- with this player
---------------------------------------------------------------------------

function playerhit(id,source)
	if source>0 then
		return 1
	else
		if invuls[id]>0 then
			return 1
		end
	end
end

------------------------------
-- There goes menu function
------------------------------

function fbuy(id,title,btn)
	if title=="Buy menu" then
		if btn==1 then
			if player(id,"money")>=11000 then
				parse("equip "..id.." 49")
				parse("setweapon "..id.." 49")
				msg2(id,"000255000You successfully bought Grenade launcher!@C")
				parse("setmoney "..id.." "..(player(id,"money")-11000))
			else
				msg2(id,"You have insufficient funds!@C")
			end
		elseif btn==2 then
			if player(id,"money")>=2000 then
				parse("equip "..id.." 64")
				msg2(id,"000255000You successfully bought Medikit!@C")
				parse("setmoney "..id.." "..(player(id,"money")-2000))
			else
				msg2(id,"You have insufficient funds!@C")
			end
		elseif btn==3 then
			if player(id,"money")>=4000 then
				parse("equip "..id.." 76")
				parse("setweapon "..id.." 76")
				msg2(id,"000255000You successfully bought Airstrike!@C")
				parse("setmoney "..id.." "..(player(id,"money")-4000))
			else
				msg2(id,"You have insufficient funds!@C")
			end
		elseif btn==4 then
			if player(id,"money")>=10000 then
				parse("equip "..id.." 85")
				parse("setweapon "..id.." 85")
				msg2(id,"000255000You successfully bought Chainsaw!@C")
				parse("setmoney "..id.." "..(player(id,"money")-10000))
			else
				msg2(id,"You have insufficient funds!@C")
			end
		elseif btn==5 then
			if player(id,"money")>=13000 then
				parse("equip "..id.." 48")
				parse("setweapon "..id.." 48")
				msg2(id,"000255000You successfully bought Rocket launcher!@C")
				parse("setmoney "..id.." "..(player(id,"money")-13000))
			else
				msg2(id,"You have insufficient funds!@C")
			end
		elseif btn==6 then
			if player(id,"money")>=13500 then
				parse("equip "..id.." 47")
				parse("setweapon "..id.." 47")
				msg2(id,"000255000You successfully bought RPG launcher!@C")
				parse("setmoney "..id.." "..(player(id,"money")-13500))
			else
				msg2(id,"You have insufficient funds!@C")
			end
		elseif btn==7 then
			if player(id,"money")>=16000 then
				if hasnuke[id]==0 then
					hasnuke[id]=1
					msg2(id,"000255000You successfully bought Nuke!@C")
					msg2(id,"000255000Use F4->Plant Nuke to plant it!@C")
					parse("setmoney "..id.." "..(player(id,"money")-16000))
				else
					msg2(id,"you already have a nuke!@C")
				end
			else
				msg2(id,"You have insufficient funds!@C")
			end
		end
	elseif title=="Skills" then
		if btn==1 then
			if hpp[id]<10 then
				hpp[id]=hpp[id]+1
				lvlsk[id]=lvlsk[id]-1
			else
				msg2(id,"You reached maximum in this@C")
			end
		elseif btn==2 then
			if app[id]<25 then
				app[id]=app[id]+1
				lvlsk[id]=lvlsk[id]-1
			else
				msg2(id,"You reached maximum in this@C")
			end
		elseif btn==3 then
			ecp[id]=ecp[id]+5
			lvlsk[id]=lvlsk[id]-1
		elseif btn==4 then
			if spp[id]<100 then
				spp[id]=spp[id]+1
				lvlsk[id]=lvlsk[id]-1
			else
				msg2(id,"You reached maximum in this@C")
			end
		elseif btn==5 then
			invul[id]=invul[id]+1
			lvlsk[id]=lvlsk[id]-1
		elseif btn==6 then
			ber[id]=ber[id]+1
			lvlsk[id]=lvlsk[id]-1
		elseif btn==7 then
			aura[id]=aura[id]+1
			lvlsk[id]=lvlsk[id]-1
		elseif btn==8 then
			regen[id]=regen[id]+1
			lvlsk[id]=lvlsk[id]-1
		elseif btn==9 then
			manap[id]=manap[id]+1
			lvlsk[id]=lvlsk[id]-1
		end
		if(btn>0) then
			srvact(id,2)
		end
		parse("setmaxhealth "..id.." "..(100+hpp[id]*15))
		if app[id]<=20 then
			parse("setarmor "..id.." "..(app[id]*10))
		else
			parse("setarmor "..id.." "..(180+app[id]))
		end
		parse("speedmod "..id.." "..spp[id])
		parse('hudtxt2 '..id..' 1 "'..msg_color_xp..'Experience: '..xp[id]..'/'..lvli[id]..'" 300 415 0')
		parse('hudtxt2 '..id..' 2 "'..msg_color_lvl..'Level: '..lvl[id]..'" 5 415 0')
	elseif title=="Active Abilities" then
		if btn==1 then
			if player(id,"money")>=10000 then
				forget(id)
				parse("setmoney "..id.." "..(player(id,"money")-10000))
			else
				msg2(id,"You can't, it costs $10000!@C")
			end
		elseif btn==2 then
			if mana[id]>=(30+invul[id]*3) then
				invuls[id]=5*invul[id]
				mana[id]=mana[id]-(30+invul[id]*3)
			else
				msg2(id,"Not enough mana@C")
			end
		elseif btn==3 then
			if mana[id]>=(25+ber[id]*5) then
				bers[id]=5*ber[id]
				mana[id]=mana[id]-(25+ber[id]*5)
			else
				msg2(id,"Not enough mana@C")
			end
		elseif btn==4 then
			if mana[id]>=(20+aura[id]*5) then
				auras[id]=aura[id]+2
				mana[id]=mana[id]-(20+aura[id]*5)
				refreshgfx(id,"aura")
			else
				msg2(id,"Not enough mana@C")
			end
		elseif btn==5 then
			if hasnuke[id]==1 then
				plantnuke(player(id,"tilex"),player(id,"tiley"),id)
				hasnuke[id]=0
			end
		elseif btn==6 then
			if hasnuke[id]==1 then
				dropnuke(player(id,"x"),player(id,"y"))
				hasnuke[id]=0
			end
		end
	end
end

---------------------------------
-- There goes save/load stuff
---------------------------------


function exp_save()
	for i=1,32 do
		if player(i,"exists") and player(i,"usgn")>0 then
			f = assert(io.open("sys/lua/npczm_saves/"..player(i,"usgn")..".sav","w"))
			f:write(lvli[i].." "..lvlir[i].." "..lvl[i].." "..xp[i].." "..lvlsk[i].." "..hpp[i].." "..app[i].." "..ecp[i].." "..spp[i].." "..regen[i].." "..ber[i].." "..invul[i].." "..aura[i].." "..manap[i])
			msg2(i,""..msg_color_saved.."Your data has been saved.")
			f:close()
		end
	end
end

function exp_load(id)
	local prs
	if player(id,"usgn")>0 then
		f = io.open("sys/lua/npczm_saves/"..player(id,"usgn")..".sav","r")
		if (f ~= nil) then
			for line in f:lines() do
				prs=toTable(line)
				lvli[id]=tonumber(prs[1])
				lvlir[id]=tonumber(prs[2])
				lvl[id]=tonumber(prs[3])
				xp[id]=tonumber(prs[4])
				lvlsk[id]=tonumber(prs[5])
				hpp[id]=tonumber(prs[6])
				app[id]=tonumber(prs[7])
				ecp[id]=tonumber(prs[8])
				spp[id]=tonumber(prs[9])
				regen[id]=tonumber(prs[10])
				ber[id]=tonumber(prs[11])
				invul[id]=tonumber(prs[12])
				aura[id]=tonumber(prs[13])
				manap[id]=tonumber(prs[14])
				mana[id]=33+manap[id]*10+lvl[id]*2
				break
			end
			f:close()
		end
	end
end